{% if oerindex_import_scripts_python_webservice_install %}
upstream import_scripts_gunicorn {
  server unix:/run/gunicorn.sock;
}
{% endif %}
server {
  listen       80;
  server_name  localhost;
  location {{ oerindex_backend_contactapi_root_path }} {
    proxy_pass {{ oerindex_backend_internal_api_base_url }}/contact/;
  }
  location {{ oerindex_backend_searchapi_root_path }} {
    proxy_pass {{ oerindex_backend_internal_api_base_url }}/search/;
  }
  # DEPRECATED: search via "api-internal/search" will be removed soon, please use search via "api/search" instead
  location {{ oerindex_public_base_path }}/api-internal/search/ {
    proxy_pass {{ oerindex_backend_internal_api_base_url }}/search/;
  }
  location {{ oerindex_backend_labelapi_root_path }} {
    proxy_pass {{ oerindex_backend_internal_api_base_url }}/label/;
  }
  # DEPRECATED: search via "api-internal/label" will be removed soon, please use search via "api/label" instead
  location {{ oerindex_public_base_path }}/api-internal/label/ {
    proxy_pass {{ oerindex_backend_internal_api_base_url }}/deprecated/label/;
  }
  location {{ oerindex_backend_oembedapi_root_path }}-json {
    proxy_pass {{ oerindex_backend_internal_api_base_url }}/oembed-json/;
  }
  location {{ oerindex_backend_oembedapi_root_path }}-xml {
    proxy_pass {{ oerindex_backend_internal_api_base_url }}/oembed-xml/;
  }
  location {{ oerindex_backend_oembedapi_root_path }} {
    proxy_pass {{ oerindex_backend_internal_api_base_url }}/oembed-json/;
  }
{% if oerindex_import_scripts_python_webservice_install %}
  location {{ oerindex_public_base_path }}/api-internal/import-scripts/python/ {
    proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    proxy_set_header X-Forwarded-Proto $scheme;
    proxy_set_header Host $http_host;
    proxy_redirect off;
    proxy_pass http://import_scripts_gunicorn/;
  }
{% endif %}
  location ~ "^{{ oerindex_public_base_path }}/((?:[A-Za-z0-9-_]{4}+){4,}(?:[A-Za-z0-9-_]{3}=|[A-Za-z0-9-_]{2}==)?)$" {
    # if-workaround, see https://www.nginx.com/resources/wiki/start/topics/depth/ifisevil/
    error_page 418 = @json_resource;
    error_page 419 = @html_resource;
    
    set $resourceId $1;
    set $requestedJson n;
    if ($http_accept ~ "application/json") {
      set $requestedJson "y";
    }
    if ($arg_format = "json") {
      set $requestedJson "y";
    }
    if ($requestedJson = "y") {
      return 418;
    }
    return 419;
  }
  location @json_resource {
    proxy_pass {{ oerindex_backend_internal_api_base_url }}/search/{{ elasticsearch_oer_index_alias_name }}/_doc/$resourceId/_source;
  }
  location @html_resource {
    proxy_pass http://127.0.0.1{{ oerindex_public_base_path }}/details/$resourceId;
  }
  location {{ oerindex_public_base_path }}/static {
    alias {{ oerindex_frontend_instdir }}/build/static;
    expires 1y;
    add_header Cache-Control "public, immutable";
  }
  location {{ oerindex_public_base_path }}/footer {
    gzip_static on;
    alias {{ oerindex_frontend_instdir }}/build/footer;
    expires 1d;
    add_header Cache-Control "public";
  }
  location {{ oerindex_public_base_path }}/vocabs {
    gzip_static on;
    alias {{ oerindex_frontend_instdir }}/build/vocabs;
    expires 1d;
    add_header Cache-Control "public";
  }
{% if oerindex_features_generate_thumbnails %}
  location {{ oerindex_public_base_path }}/thumbnail {
    gzip_static on;
    alias {{ thumbnail_webserver_instdir }};
    try_files $uri $uri/ =404;
    expires 7d;
    add_header Cache-Control "public";
  }
{% endif %}
  location {{ oerindex_public_base_path }}/api-internal/versions.json {
    alias /var/www/oersi/versions.json;
  }
  location {{ oerindex_public_base_path }} {
    gzip_static on;
    alias {{ oerindex_frontend_instdir }}/build;
    index  index.html;
    try_files $uri $uri/ /index.html =404;
    add_header Cache-Control "no-store, no-cache, must-revalidate";
  }
  location / {
    return 301 {{ oerindex_public_base_path }};
  }
  try_files $uri $uri/ /index.html;
  error_page   500 502 503 504  /50x.html;
  location = /50x.html {
    root   /usr/share/nginx/html;
  }
}
